com.io7m.jpra.model.type_expressions

## Interface TypeExprMatcherType<I,T,A,E extends Exception>

- Type Parameters:
    `A` - The type of returned values
    `E` - The type of raised exceptions
    `I` - The type of identifiers
    `T` - The type of type information

      public interface TypeExprMatcherType<I,T,A,E extends Exception>

  The type of type expression matchers.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `A` | `matchBooleanSet(TypeExprBooleanSet<I,T> e)` Match a `boolean-set` expression.
    `A` | `matchExprArray(TypeExprArray<I,T> e)` Match an `array` expression.
    `A` | `matchExprFloat(TypeExprFloat<I,T> e)` Match a `float` expression.
    `A` | `matchExprIntegerSigned(TypeExprIntegerSigned<I,T> e)` Match an `integer signed` expression.
    `A` | `matchExprIntegerSignedNormalized(TypeExprIntegerSignedNormalized<I,T> e)` Match an `integer signed-normalized` expression.
    `A` | `matchExprIntegerUnsigned(TypeExprIntegerUnsigned<I,T> e)` Match an `integer unsigned` expression.
    `A` | `matchExprIntegerUnsignedNormalized(TypeExprIntegerUnsignedNormalized<I,T> e)` Match an `integer unsigned-normalized` expression.
    `A` | `matchExprMatrix(TypeExprMatrix<I,T> e)` Match a `matrix` expression.
    `A` | `matchExprString(TypeExprString<I,T> e)` Match a `string` expression.
    `A` | `matchExprVector(TypeExprVector<I,T> e)` Match a `vector` expression.
    `A` | `matchName(TypeExprName<I,T> e)` Match a name expression.
    `A` | `matchTypeOfField(TypeExprTypeOfField<I,T> e)` Match a `type-of` expression.

- - ### Method Detail

    - #### matchExprIntegerSigned

          A matchExprIntegerSigned(TypeExprIntegerSigned<I,T> e)
                            throws E extends Exception

      Match an `integer signed` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprIntegerSignedNormalized

          A matchExprIntegerSignedNormalized(TypeExprIntegerSignedNormalized<I,T> e)
                                      throws E extends Exception

      Match an `integer signed-normalized` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprIntegerUnsigned

          A matchExprIntegerUnsigned(TypeExprIntegerUnsigned<I,T> e)
                              throws E extends Exception

      Match an `integer unsigned` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprIntegerUnsignedNormalized

          A matchExprIntegerUnsignedNormalized(TypeExprIntegerUnsignedNormalized<I,T> e)
                                        throws E extends Exception

      Match an `integer unsigned-normalized` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprArray

          A matchExprArray(TypeExprArray<I,T> e)
                    throws E extends Exception

      Match an `array` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprFloat

          A matchExprFloat(TypeExprFloat<I,T> e)
                    throws E extends Exception

      Match a `float` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprVector

          A matchExprVector(TypeExprVector<I,T> e)
                     throws E extends Exception

      Match a `vector` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprMatrix

          A matchExprMatrix(TypeExprMatrix<I,T> e)
                     throws E extends Exception

      Match a `matrix` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchExprString

          A matchExprString(TypeExprString<I,T> e)
                     throws E extends Exception

      Match a `string` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchName

          A matchName(TypeExprName<I,T> e)
               throws E extends Exception

      Match a name expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchTypeOfField

          A matchTypeOfField(TypeExprTypeOfField<I,T> e)
                      throws E extends Exception

      Match a `type-of` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

    - #### matchBooleanSet

          A matchBooleanSet(TypeExprBooleanSet<I,T> e)
                     throws E extends Exception

      Match a `boolean-set` expression.
      Parameters:
        `e` - The expression
      Returns:
        A value of `A`
      Throws:
        `E` - If required
        `E extends Exception`

Copyright © 2015 <code@io7m.com> http://io7m.com